# 4.4.4

Release date: `2020-07-10`

## Core

- [NXDRIVE-1848](https://jira.nuxeo.com/browse/NXDRIVE-1848): Remove dependency on `rfc3987` for URL parsing
- [NXDRIVE-2121](https://jira.nuxeo.com/browse/NXDRIVE-2121): Lower logging level of "Icon folder cannot be set"
- [NXDRIVE-2133](https://jira.nuxeo.com/browse/NXDRIVE-2133): [macOS] Skip errors on file creation time modification
- [NXDRIVE-2139](https://jira.nuxeo.com/browse/NXDRIVE-2139): Make the custom user agent effective
- [NXDRIVE-2160](https://jira.nuxeo.com/browse/NXDRIVE-2160): Lower logging level of "Error while stopping FinderSync"
- [NXDRIVE-2162](https://jira.nuxeo.com/browse/NXDRIVE-2162): Enforce disk space retrieval robustness
- [NXDRIVE-2170](https://jira.nuxeo.com/browse/NXDRIVE-2170): Fix new errors found by `codespell` 1.17.0
- [NXDRIVE-2174](https://jira.nuxeo.com/browse/NXDRIVE-2174): Use versions check functions from the Python client
- [NXDRIVE-2183](https://jira.nuxeo.com/browse/NXDRIVE-2183): Fix chunked upload using an obsolete batch ID in certain circumstances
- [NXDRIVE-2184](https://jira.nuxeo.com/browse/NXDRIVE-2184): Fix `mypy` issues following the update to mypy 0.780
- [NXDRIVE-2185](https://jira.nuxeo.com/browse/NXDRIVE-2185): Be more specific on HTTP error handling when fetching the batch ID associated to an upload
- [NXDRIVE-2187](https://jira.nuxeo.com/browse/NXDRIVE-2187): New language: Basque (eu)
- [NXDRIVE-2188](https://jira.nuxeo.com/browse/NXDRIVE-2188): Remove the Hebrew language
- [NXDRIVE-2190](https://jira.nuxeo.com/browse/NXDRIVE-2190): Refactored Remote client uploads
- [NXDRIVE-2191](https://jira.nuxeo.com/browse/NXDRIVE-2191): Introduced the `State` object
- [NXDRIVE-2206](https://jira.nuxeo.com/browse/NXDRIVE-2206): [macOS] Fix the favorites unregistering process
- [NXDRIVE-2226](https://jira.nuxeo.com/browse/NXDRIVE-2226): Disable temporarily S3 capability

### Direct Edit

- [NXDRIVE-1786](https://jira.nuxeo.com/browse/NXDRIVE-1786): Handle corrupted downloads
- [NXDRIVE-2112](https://jira.nuxeo.com/browse/NXDRIVE-2112): Always start a fresh download
- [NXDRIVE-2113](https://jira.nuxeo.com/browse/NXDRIVE-2113): Add a warning on upload when server-side lock is disabled
- [NXDRIVE-2116](https://jira.nuxeo.com/browse/NXDRIVE-2116): Requests `Invalid byte range` multiple of total binary size
- [NXDRIVE-2124](https://jira.nuxeo.com/browse/NXDRIVE-2124): Uniformize the name: "Direct Edit"
- [NXDRIVE-2129](https://jira.nuxeo.com/browse/NXDRIVE-2129): Orphaned documents should first be remotely unlocked before being cleaned up
- [NXDRIVE-2131](https://jira.nuxeo.com/browse/NXDRIVE-2131): Handle HTTP 413 error: Request Entity Too Large
- [NXDRIVE-2132](https://jira.nuxeo.com/browse/NXDRIVE-2132): Do not allow Direct Edit on proxies

### Direct Transfer

- [NXDRIVE-1926](https://jira.nuxeo.com/browse/NXDRIVE-1926): Display global transfer metrics
- [NXDRIVE-2065](https://jira.nuxeo.com/browse/NXDRIVE-2065): Leverage the `FileManager`
- [NXDRIVE-2208](https://jira.nuxeo.com/browse/NXDRIVE-2208): Enable to cancel one or more transfer
- [NXDRIVE-2155](https://jira.nuxeo.com/browse/NXDRIVE-2155): Improvements on the main popup
- [NXDRIVE-2158](https://jira.nuxeo.com/browse/NXDRIVE-2158): Review the warning message on conflict popup
- [NXDRIVE-2219](https://jira.nuxeo.com/browse/NXDRIVE-2219): Display a remote folder icon for each transfer
- [NXDRIVE-2220](https://jira.nuxeo.com/browse/NXDRIVE-2220): Asynchronous planification of uploads
- [NXDRIVE-2221](https://jira.nuxeo.com/browse/NXDRIVE-2221): Improve performances to prevent GUI freezes
- [NXDRIVE-2232](https://jira.nuxeo.com/browse/NXDRIVE-2232): Add an option to control the database batch size
- [NXDRIVE-2235](https://jira.nuxeo.com/browse/NXDRIVE-2235): Temporary disable duplicate prevention

## GUI

- [NXDRIVE-2138](https://jira.nuxeo.com/browse/NXDRIVE-2138): Add settings for features
- [NXDRIVE-2150](https://jira.nuxeo.com/browse/NXDRIVE-2150): Change the disk space usage border color
- [NXDRIVE-2223](https://jira.nuxeo.com/browse/NXDRIVE-2223): Select Web UI by default in Settings
- [NXDRIVE-2227](https://jira.nuxeo.com/browse/NXDRIVE-2227): Fix translations formatting

## Packaging / Build

- [NXDRIVE-2016](https://jira.nuxeo.com/browse/NXDRIVE-2016): Upgrade Python from 3.7.4 to 3.7.7
- [NXDRIVE-2146](https://jira.nuxeo.com/browse/NXDRIVE-2146): Do not package `Qt5RemoteObjects` DLL and shared library
- [NXDRIVE-2175](https://jira.nuxeo.com/browse/NXDRIVE-2175): Move Crowdin synchronization to GitHub Actions
- [NXDRIVE-2203](https://jira.nuxeo.com/browse/NXDRIVE-2203): Use Python 3 in release scripts
- [NXDRIVE-2204](https://jira.nuxeo.com/browse/NXDRIVE-2204): Add notifications when release jobs fail
- [NXDRIVE-2215](https://jira.nuxeo.com/browse/NXDRIVE-2215): Force push on tag creation when doing an alpha release

## Tests

- [NXDRIVE-2127](https://jira.nuxeo.com/browse/NXDRIVE-2127): Fixes for functional tests using `tox`
- [NXDRIVE-2171](https://jira.nuxeo.com/browse/NXDRIVE-2171): Use `pip-sync` to keep test environments up-to-date
- [NXDRIVE-2177](https://jira.nuxeo.com/browse/NXDRIVE-2177): Review the logging format in tests
- [NXDRIVE-2179](https://jira.nuxeo.com/browse/NXDRIVE-2179): Enable back failed test reports
- [NXDRIVE-2189](https://jira.nuxeo.com/browse/NXDRIVE-2189): Move non-Python test files to specific folders
- [NXDRIVE-2199](https://jira.nuxeo.com/browse/NXDRIVE-2199): Use the `FileManager` importer in tests
- [NXDRIVE-2200](https://jira.nuxeo.com/browse/NXDRIVE-2200): Fix tests from `test_special_characters.py`
- [NXDRIVE-2201](https://jira.nuxeo.com/browse/NXDRIVE-2201): Move the NXDRIVE-1033 test in its own test file
- [NXDRIVE-2202](https://jira.nuxeo.com/browse/NXDRIVE-2202): Move the NXDRIVE-947 test in its own test file
- [NXDRIVE-2211](https://jira.nuxeo.com/browse/NXDRIVE-2211): Use `DOCTYPE_FOLDERISH` for creating the workspace in tests
- [NXDRIVE-2212](https://jira.nuxeo.com/browse/NXDRIVE-2212): [Windows] Fix `pytest_cache` folder removal
- [NXDRIVE-2213](https://jira.nuxeo.com/browse/NXDRIVE-2213): [Windows] Shut down warnings about `QtBluetooth` files removal
- [NXDRIVE-2237](https://jira.nuxeo.com/browse/NXDRIVE-2237): Update the Nuxeo snapshot to 11.2

## Docs

- [NXDRIVE-2130](https://jira.nuxeo.com/browse/NXDRIVE-2130): Add Direct Edit and Direct Transfer sections in the changelog

## Minor Changes

- Added `importlib-metadata` 1.6.1
- Added `pip-tools` 5.2.1
- Added `wheel` 0.34.2
- Added `zipp` 3.1.0
- Upgraded `boto3` from 1.12.19 to 1.14.0
- Upgraded `botocore` from 1.15.19 to 1.17.0
- Upgraded `certifi` from 2019.11.28 to 2020.6.20
- Upgraded `idna` from 2.9 to 2.10
- Upgraded `importlib-metadata` from 1.6.1 to 1.7.0
- Upgraded `jmespath` from 0.9.5 to 0.10.0
- Upgraded `markdown` from 3.2.1 to 3.2.2
- Upgraded `nuxeo` commit-764c064 to commit-f608dec
- Upgraded `pip` from 20.0.2 to 20.1.1
- Upgraded `pycryptodomex` from 3.9.7 to 3.9.8
- Upgraded `pyobjc-core` from 6.1 to 6.2.1
- Upgraded `pyobjc-framework-Cocoa` from 6.1 to 6.2.1
- Upgraded `pyobjc-framework-CoreServices` from 6.1 to 6.2.1
- Upgraded `pyobjc-framework-FSEvents` from 6.1 to 6.2.1
- Upgraded `pyobjc-framework-ScriptingBridge` from 6.1 to 6.2.1
- Upgraded `pyobjc-framework-SystemConfiguration` from 6.1 to 6.2.1
- Upgraded `pyqt5-sip` from 12.7.0 to 12.8.0
- Upgraded `pywin32` from 227 to 228
- Upgraded `requests` from 2.23.0 to 2.24.0
- Upgraded `sentry-sdk` from 0.14.3 to 0.15.1
- Upgraded `six` from 0.14.0 to 0.15.0
- Upgraded `tld` from 0.11.9 to 0.12.2
- Upgraded `urllib3` from 1.25.8 to 1.25.9
- Upgraded `watchdog` from 0.10.2 to 0.10.3
- Removed `rfc3987`
- Packaging: Added `requests` 2.24.0
- Packaging: Upgraded `pyyaml` from 5.1.2 to 5.3.1

## Technical Changes

- Added `Application.exit_app()`
- Added `Application.direct_transfer_model`
- Added `Application.close_direct_transfer_window()`
- Added `Application.confirm_cancel_transfer()`
- Added `Application.destroyed_server_folders()`
- Added `Application.refresh_direct_transfer_items()`
- Added `Application.show_direct_transfer_window()`
- Added `Application.update_direct_transfer_items_count()`
- Removed `Application.add_qml_import_path()`
- Removed `conf_name` keyword argument to `CLIHandler.load_config()`
- Added `Engine.cancel_upload()`
- Added `Engine.directTranferItemsCount` signal
- Added `Engine.direct_transfer_async()`
- Added `remote_ref` argument to `Engine.direct_transfer()`
- Added `is_direct_transfer` keyword argument to `Engine.pause_transfer()`
- Added `is_direct_transfer` keyword argument to `Engine.remove_transfer()`
- Added `is_direct_transfer` keyword argument to `Engine.resume_transfer()`
- Renamed `Engine._start` signal to `started`
- Added `EngineDAO.directTransferUpdated`
- Added `EngineDAO.get_dt_items_count()`
- Added `EngineDAO.get_dt_upload()`
- Added `EngineDAO.get_dt_uploads_with_status()`
- Added `EngineDAO.plan_many_direct_transfer_items()`
- Added `EngineDAO.queue_many_direct_transfer_items()`
- Added `EngineDAO.update_upload()`
- Added `is_direct_transfer` keyword argument to `EngineDAO.pause_transfer()`
- Added `is_direct_transfer` keyword argument to `EngineDAO.remove_transfer()`
- Added `is_direct_transfer` keyword argument to `EngineDAO.resume_transfer()`
- Added `size` positional argument to `DownloadAction`
- Removed `Download.filesize`
- Added `FileAction.is_direct_transfer`
- Changed `FileAction.__init__(..., size, ...)` from float keyword argument to int positional argument
- Added `FoldersDialog.remote_folder_ref`
- Added `size` positional argument to `LinkingAction`
- Added `Manager.get_feature_state()`
- Added `Manager.set_feature_state()`
- Added `NuxeoDocumentInfo.is_proxy`
- Added `Options.database_batch_size`
- Added `Remote.cancel_batch()`
- Added `Remote.get_note()`
- Removed `Remote.direct_transfer()`. Use `DirectTransferUploader.upload()` instead.
- Removed `Remote.get_document_or_none()`. Use `DirectTransferUploader.get_document_or_none()` instead.
- Removed `Remote.link_blob_to_doc()`. Use `BaseUploader.link_blob_to_doc()` instead.
- Removed `Remote.upload_chunks()`. Use `BaseUploader.upload_chunks()` instead.
- Added `QMLDriveApi.get_direct_transfer_items()`
- Added `QMLDriveApi.get_dt_items_count()`
- Added `QMLDriveApi.get_features_list()`
- Added `is_direct_transfer` keyword argument to `QMLDriveApi.pause_transfer()`
- Added `is_direct_transfer` keyword argument to `QMLDriveApi.resume_transfer()`
- Added `Transfer.filesize`
- Added `Upload.is_direct_transfer`
- Added `Upload.remote_parent_ref`
- Added `Upload.remote_parent_title`
- Added `size` positional argument to `UploadAction`
- Added `size` positional argument to `VerificationAction`
- Added client/uploader
- Added constants.py::`USER_AGENT`
- Added engine/workers.py::`Runner`
- Removed engine/dao/sqlite.py::`str_to_path()`
- Added features.py::`Beta`
- Added features.py::`DisabledFeatures`
- Added options.py::`CallableFeatureHandler`
- Removed options.py::`handle_feat_auto_update()`
- Removed options.py::`handle_feat_direct_edit()`
- Removed options.py::`handle_feat_direct_transfer()`
- Removed options.py::`handle_feat_s3()`
- Added state.py
- Added utils.py::`config_paths()`
- Added utils.py::`disk_space()`
- Added utils.py::`grouper()`
- Added utils.py::`save_config()`
- Added `size` to each entry returned by utils.py::`get_tree_list()`
- Changed order of elements returned by utils.py::`get_tree_list()`
- Removed utils.py::`cmp()`. Use `nuxeo.utils.cmp()` instead.
- Removed utils.py::`version_compare()`. Use `nuxeo.utils.version_compare()` instead.
- Removed utils.py::`version_compare_client()`. Use `nuxeo.utils.version_compare_client()` instead.
- Removed utils.py::`version_le()`. Use `nuxeo.utils.version_le()` instead.
- Removed utils.py::`version_lt()`. Use `nuxeo.utils.version_lt()` instead.
- Added view.py::`DirectTransferModel`
